var model = require("./model");
var _ = require("lodash");
var bcrypt = require("bcrypt");


function User(){

}

User.prototype = new model("users");
User.prototype.constructor === model;
User.prototype.insert = function (data) {
	if(_.has(data, "password")){
		var salt = bcrypt.genSaltSync(10);
		data.password = bcrypt.hashSync(data.password, salt);
	}
	if(!_.has(data, "role")){
		data.role = "user";
	}
	// Check for exisiting user email or username
	if(model.prototype.select.call(this,{email:data.email}).length > 0 || model.prototype.select.call(this,{username: data.username}).length > 0){
		return false;
	}else{
		return _.omit(model.prototype.insert.call(this, data), "password");
	}
};
User.prototype.update = function (_id, data) {
	if(_.has(data, "password")){
		var salt = bcrypt.genSaltSync(10);
		data.password = bcrypt.hashSync(data.password, salt);
	}
	return model.prototype.update.call(this, _id, data);
};

// Returns data without password hash.
User.prototype.select = function (query) {
	var data = model.prototype.select.call(this, query);
	return _.map(data, function (obj) {
		return _.omit(obj, "password");
	} );

};

User.prototype.findOne = function (data) {
	return _.omit(model.prototype.findOne.call(this, data), "password");
};
User.prototype.authenticate = function (data) {
	if(data && ( (_.has(data, "email") || _.has(data, "username") ) && _.has(data, "password"))){
		var usr = model.prototype.select.call(this,data);
		if(usr && usr.length == 1){
			if(bcrypt.compareSync(data.password, usr[0].password)){
				return {
					status:200,
					message:"User Authenticated",
					user: _.omit(usr[0], "password")
				};
			}else{
				return {
				status:401,
				message:"Email or password incorrect!"
				};
			}
		}
		else{
			return {
				status:401,
				message:"User Not Found!"
				};
		}
	}
	else{
		return {
			status:400,
			message:"No email or password"
			};
	}
};

module.exports = User;
